require File.dirname(__FILE__) + '/../../../spec_helper'
require File.dirname(__FILE__) + '/sample_archetype_spec'
require 'rexml/document'
include OpenEHR::Serializer

describe XMLSerializer do
  it_should_behave_like 'sample archetype'

  before(:each) do
    @xml_serializer = XMLSerializer.new(@archetype)
  end

  it 'should be an instance of XMLSerializer' do
    @xml_serializer.should be_an_instance_of XMLSerializer
  end

  it 'should return XML formatted header' do
    @xml_serializer.header.should == <<END
<archetype_id>
  <value>openEHR-EHR-SECTION.test.v1</value>
</archetype_id>
<concept>at0000</concept>
<original_language>
  <terminology_id>
    <value>ISO_639-1</value>
  </terminology_id>
  <code_string>ja</code_string>
</original_language>
END
  end

  it 'should return XML formatted description' do
    @xml_serializer.description.should == <<END
<description>
  <original_author id="name">Shinji KOBAYASHI</original_author>
  <original_author id="organisation">openEHR.jp</original_author>
  <original_author id="email">skoba@moss.gr.jp</original_author>
  <lifecycle_state>draft</lifecycle_state>
  <details>
    <language>
      <terminology_id>
        <value>ISO_639-1</value>
      </terminology_id>
      <code_string>ja</code_string>
    </language>
    <purpose>Serializer test</purpose>
    <misuse>evaluate message</misuse>
  </details>
</description>
END
  end
end
